/* TileAlchemy Engine namespace */
var TAEngine;

if(!TAEngine)
	TAEngine = {};
	
TAEngine.MoveUp		= false;
TAEngine.MoveLeft	= false;
TAEngine.MoveDown	= false;
TAEngine.MoveRight	= false;
TAEngine.Jump		= false;
TAEngine.Action1	= false;
TAEngine.Action2	= false;
TAEngine.Action3	= false;
TAEngine.Start		= false;
TAEngine.Select		= false;
	
TAEngine.ControllerHelper = function() {
	//Key Codes for keyboard listeners
	var KEY_W 				= 87;
		this.keyWHeld 		= false;
	var KEY_A 				= 65;
		this.keyAHeld 		= false;
	var KEY_S 				= 83;
		this.keySHeld 		= false;
	var KEY_D 				= 68;
		this.keyDHeld 		= false;
	var KEY_TAB 			= 9;
		this.keyTabHeld 	= false;
	var KEY_SPACE 			= 32;
		this.keySpaceHeld 	= false;
	var KEY_Z 				= 90;
		this.keyZHeld 		= false;
	var KEY_X 				= 88;
		this.keyXHeld 		= false;
	var KEY_SHIFT 			= 16;
		this.keyShiftHeld 	= false;
	var KEY_UP 				= 38;
		this.keyUpHeld 		= false;
	var KEY_LEFT 			= 37;
		this.keyLeftHeld 	= false;
	var KEY_DOWN 			= 40;
		this.keyDownHeld 	= false;
	var KEY_RIGHT 			= 39;
		this.keyRightHeld 	= false;
	var KEY_P 				= 80;
		this.keyPHeld 		= false;
	var KEY_ENTER			= 13;
		this.keyEnterHeld 	= false;
	
	//Handle Key Being Pressed
	this.handleKeyDown = function(e) {
		//cross browser issues exist
		if(!e){var e = window.event;}
		switch(e.keyCode) {
			case KEY_W:
				if(!this.keyWHeld) {
					this.keyWHeld = true;
					console.log("w pressed!");
				}
				break;
			case KEY_A:
				if(!this.keyAHeld) {
					this.keyAHeld = true;
					console.log("a pressed!");
				}
				break;
			case KEY_S:
				if(!this.keySHeld) {
					this.keySHeld = true;
					console.log("s pressed!");
				}
				break;
			case KEY_D:
				if(!this.keyDHeld) {
					this.keyDHeld = true;
					console.log("d pressed!");
				}
				break;
			case KEY_TAB:
				if(!this.keyTabHeld) {
					this.keyTabHeld = true;
					console.log("tab pressed!");
				}
				break;
			case KEY_SPACE:
				if(!this.keySpaceHeld) {
					this.keySpaceHeld = true;
					console.log("space pressed!");
					TAEngine.Jump = true;
				}
				break;
			case KEY_Z:
				if(!this.keyZHeld) {
					this.keyZHeld = true;
					console.log("z pressed!");
				}
				break;
			case KEY_X:
				if(!this.keyXHeld) {
					this.keyXHeld = true;
					console.log("x pressed!");
				}
				break;
			case KEY_SHIFT:
				if(!this.keyShiftHeld) {
					this.keyShiftHeld = true;
					console.log("shift pressed!");
				}
				break;
			case KEY_UP:
				if(!this.keyUpHeld) {
					this.keyUpHeld = true;
					console.log("up pressed!");
					TAEngine.MoveUp = true;
				}
				break;
			case KEY_LEFT:
				if(!this.keyLeftHeld) {
					this.keyLeftHeld = true;
					console.log("left pressed!");
					TAEngine.MoveLeft = true;
				}
				break;
			case KEY_DOWN:
				if(!this.keyDownHeld) {
					this.keyDownHeld = true;
					console.log("down pressed!");
					TAEngine.MoveDown = true;
					}
				break;
			case KEY_RIGHT:
				if(!this.keyRightHeld) {
					this.keyRightHeld = true;
					console.log("right pressed!");
					TAEngine.MoveRight = true;
				}
				break;
			case KEY_P:
				if(!this.keyPHeld) {
					this.keyPHeld = true;
					console.log("p pressed!");
				}
				break;
			case KEY_ENTER:
				if(!this.keyEnterHeld) {
					this.keyEnterHeld = true;
					console.log("enter pressed!");
				}
				break;
		}
	}
	
	//Handle Key Being Released
	this.handleKeyUp = function(e) {
		//cross browser issues exist
		if(!e){var e = window.event;}
		switch(e.keyCode) {
			case KEY_W:
				if(this.keyWHeld) {
					this.keyWHeld = false;
					console.log("w released!");
				}
				break;
			case KEY_A:
				if(this.keyAHeld) {
					this.keyAHeld = false;
					console.log("a released!");
				}
				break;
			case KEY_S:
				if(this.keySHeld) {
					this.keySHeld = false;
					console.log("s released!");
				}
				break;
			case KEY_D:
				if(this.keyDHeld) {
					this.keyDHeld = false;
					console.log("d released!");
				}
				break;
			case KEY_TAB:
				if(this.keyTabHeld) {
					this.keyTabHeld = false;
					console.log("tab released!");
				}
				break;
			case KEY_SPACE:
				if(this.keySpaceHeld) {
					this.keySpaceHeld = false;
					console.log("space released!");
					TAEngine.Jump = false;
				}
				break;
			case KEY_Z:
				if(this.keyZHeld) {
					this.keyZHeld = false;
					console.log("z released!");
				}
				break;
			case KEY_X:
				if(this.keyXHeld) {
					this.keyXHeld = false;
					console.log("x released!");
				}
				break;
			case KEY_SHIFT:
				if(this.keyShiftHeld) {
					this.keyShiftHeld = false;
					console.log("shift released!");
				}
				break;
			case KEY_UP:
				if(this.keyUpHeld) {
					this.keyUpHeld = false;
					console.log("up released!");
					TAEngine.MoveUp = false;
				}
				break;
			case KEY_LEFT:
				if(this.keyLeftHeld) {
					this.keyLeftHeld = false;
					console.log("left released!");
					TAEngine.MoveLeft = false;
				}
				break;
			case KEY_DOWN:
				if(this.keyDownHeld) {
					this.keyDownHeld = false;
					console.log("down released!");
					TAEngine.MoveDown = false;
					}
				break;
			case KEY_RIGHT:
				if(this.keyRightHeld) {
					this.keyRightHeld = false;
					console.log("right released!");
					TAEngine.MoveRight = false;
				}
				break;
			case KEY_P:
				if(this.keyPHeld) {
					this.keyPHeld = false;
					console.log("p released!");
				}
				break;
			case KEY_ENTER:
				if(this.keyEnterHeld) {
					this.keyEnterHeld = false;
					console.log("enter released!");
				}
				break;
		}
	}
	
	//Setup Keyboard Events
	document.onkeydown = this.handleKeyDown;
	document.onkeyup = this.handleKeyUp;
	
};